﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Telerik.WinControls
Imports Telerik.WinControls.UI

Namespace _1152935
    Partial Public Class RadForm1
        Inherits Telerik.WinControls.UI.RadForm

        Public Sub New()
            InitializeComponent()
            AddHandler Me.radTextBoxControl1.CreateTextBlock, AddressOf RadTextBoxControl1_CreateTextBlock
            Me.radTextBoxControl1.Text = "Please, click here or here"
            AddHandler Me.radTextBoxControl1.MouseDown, AddressOf TextBoxElement_MouseDown
        End Sub

        Private Sub TextBoxElement_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs)
            Dim clickedElement = TryCast(radTextBoxControl1.ElementTree.GetElementAtPoint(e.Location), ButtonTextBlock)
            If clickedElement IsNot Nothing Then
                RadMessageBox.Show("Button: " & clickedElement.Tag & "Handled Outside", "Message")
            End If
        End Sub

        Private count As Integer = 0
        Private Sub RadTextBoxControl1_CreateTextBlock(ByVal sender As Object, ByVal e As CreateTextBlockEventArgs)

            If e.Text = "here" Then
                e.TextBlock = New ButtonTextBlock() With {.Tag = count}
                count += 1
            End If
        End Sub
    End Class
    Public Class ButtonTextBlock
        Inherits RadButtonElement
        Implements ITextBlock

        Private Sub ITextBlock_Measure(ByVal availableSize As SizeF) Implements ITextBlock.Measure
            MyBase.Measure(availableSize)
        End Sub

        Private Sub ITextBlock_Arrange(ByVal finalRectangle As RectangleF) Implements ITextBlock.Arrange
            MyBase.Arrange(finalRectangle)
        End Sub

        Private Property ITextBlock_Text() As String Implements ITextBlock.Text
            Get
                Return MyBase.Text
            End Get
            Set(value As String)
                MyBase.Text = Value
            End Set
        End Property

        Private ReadOnly Property ITextBlock_DesiredSize() As SizeF Implements ITextBlock.DesiredSize
            Get
                Return MyBase.DesiredSize
            End Get
        End Property

        Private index_ As Integer
        Private offset_ As Integer
        Private customText As New LightVisualElement()

        Public Sub New()
            Me.index_ = 0
            Me.offset_ = 0
            Me.MaxSize = New Size(0, 12)

            Me.DisplayStyle = DisplayStyle.None
            customText.ShouldHandleMouseInput = False
            customText.NotifyParentOnMouseInput = True
            customText.DrawText = True
            customText.Text = "Custom Text"
            Me.Children.Add(customText)
        End Sub

        Protected Overrides ReadOnly Property ThemeEffectiveType() As Type
            Get
                Return GetType(RadButtonElement)
            End Get
        End Property

        Public Property Index() As Integer Implements ITextBlock.Index
            Get
                Return Me.index_
            End Get
            Set(ByVal value As Integer)
                Me.index_ = value
            End Set
        End Property

        Public ReadOnly Property Length() As Integer Implements ITextBlock.Length
            Get
                Return 1
            End Get
        End Property

        Public Property Offset() As Integer Implements ITextBlock.Offset
            Get
                Return Me.offset_
            End Get
            Set(ByVal value As Integer)
                Me.offset_ = value
            End Set
        End Property

        Private ControlBoundingRectangle_ As Rectangle

        Public ReadOnly Property ControlBoundingRectangle1 As Rectangle Implements ITextBlock.ControlBoundingRectangle
            Get
                Return ControlBoundingRectangle_
            End Get
        End Property

        Public Function GetCharacterIndexFromX(ByVal x As Single) As Integer Implements ITextBlock.GetCharacterIndexFromX
            Dim bounds_ As RectangleF = Me.ControlBoundingRectangle
            Dim median As Single = bounds_.X + bounds_.Width \ 2
            Return If(x <= median, 0, 1)
        End Function

        Public Function GetRectangleFromCharacterIndex(ByVal index As Integer, ByVal trailEdge As Boolean) As RectangleF Implements ITextBlock.GetRectangleFromCharacterIndex

            Dim bounds_ = Me.ControlBoundingRectangle

            If index = 1 Then
                bounds_.X = bounds_.Right
                bounds_.Width = 0
            End If

            Return bounds_
        End Function

        Protected Overrides Sub OnClick(ByVal e As EventArgs)
            MyBase.OnClick(e)

            Dim tag_ = Me.Tag
            RadMessageBox.Show("Button: " & Tag & "Handled inside", "Message")
        End Sub
    End Class

     
End Namespace
